/**********************************************************************\
**
**                              Copyright (c) by
**                          HENGSTLER GmbH, Aldingen
**
**      This  software  is furnished under a licence and may be used and
**      copied only in accordance with the terms  of  such  licence  and
**      with the inclusion of the above copyright notice.  This software
**      or any other copies thereof may not  be  provided  or  otherwise
**      made  available  to any other person.  No title to and ownership
**      of the software is hereby transferred.
**
**      The  information  in  this software is subject to change without
**      notice and should not be construed as a commitment by Hengstler.
**
**  Module:      C56SdkDemo11DlgMain.h
**  Facility:    S684002 - Hengstler C56 Printer Driver for Windows XP/7/8/10
**  Component:   C56 SDK Demo Application 10 (C56SdkDemo11)
**  Environment: Windows XP/7/8/10
**  Compiler:    Microsoft Visual Studio 2010
**  Abstract:    Header file of module C56SdkDemo11DlgMain.cpp
**  Notes:       -
**
\**********************************************************************/

/*
** COMPILER
*/

#pragma once

//******************************************************************************************
// CLASS:     CC56SdkDemo11DlgMain 
// ABSTRACT:  Printer C-56 SDK Demo 11 main-dialog
//******************************************************************************************

class CC56SdkDemo11DlgMain : public CDialog
{
   public: 

      //-- Construction
      CC56SdkDemo11DlgMain(CWnd* pParent = NULL);   
      
      //-- Dialogdata
      enum { IDD = IDD_C56SDKDEMO11_DLGMAIN };

   protected:

      //-- Member variables
      HICON           m_hIcon;                              // Handle of icon
      CString         m_strPrinter;                         // Selected printer driver 
      UINT_PTR        m_puiPrinterStatusInquiryTimer;       // Timer for printer status inquiry
      DWORD           m_dwPrinterStatusInquiryCounter;      // Printer status inquiry counter
      DWORD           m_dwPrinterStatusInquiryFaults;       // Printer status inquiry faults
      DWORD           m_dwPrinterStatusInquiryIntervalMs;   // Printer status inquiry interval in millisecons
      BOOL            m_fPrinterStatusInquiryEnabled;       // Flag indicating inquiry 
      BOOL            m_fPrinterStatusDwordValid;           // Printer status DWORD valid flag
      BYTE            m_aubPrinterStatusDword[4];           // Printer status DWORD

      virtual void DoDataExchange(CDataExchange* pDX);      // DDX/DDV-Untersttzung

      virtual BOOL    OnInitDialog();
      afx_msg VOID    OnTimer(UINT_PTR nIdEvent);
      afx_msg void    OnSysCommand(UINT nID, LPARAM lParam);
      afx_msg void    OnPaint();
      afx_msg void    OnBnClickedButtonInquirePrinterStatus();
      afx_msg void    OnBnClickedButtonResetCounters();
      afx_msg HCURSOR OnQueryDragIcon();

      DECLARE_MESSAGE_MAP()

      void            GetDlgItems();
      void            SetDlgItems();
      void            UpdateDlgItems();
      void            LoadDlgItems();
      void            StoreDlgItems();

      void            InquirePrinterStatus();
    };
